Bug 24241 - Лишняя зависимость на Apache::Util
: Лишняя зависимость на Apache::Util
Status: CLOSED FIXED
: Sisyphus
(All bugs in Sisyphus/perl-Template)
: unstable
: all Linux
: P2 critical
Assigned To:
:
:
:
:
:
  Show dependency tree
 
Reported: 2010-10-07 11:14 by
Modified: 2011-10-24 11:38 (History)


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2010-10-07 11:14:17
Модуль Template::Toolkit может использовать как Apache::Util, так и
HTML::Entities в динамическом фильтре html. Т.о. достаточно только одного из
них для работы данного функционала.

Зависимость от Apache::Util порождает тяжёлую зависимость на веб-сервер Apache1
и модуль mod_perl к нему. Причём для использования Template::Toolkit никаких
веб-серверов в принципе и не нужно. Ещё хуже ситуация если используется другой
веб-сервер и наличие лишнего веб-сервера на системе неприятно по многим
причинам.

Наличие этих модулей определяется в момент исполнения с использованием
конструкции eval{}, но в блоке eval содержится не вызовы require, а процедура,
которая уже делает require. Т.о. при определении зависимостей оба модуля
попадают в жёсткие зависимости пакета perl-Template.

Как вариант обхода проблемы с лишней зависимостью, можно перетащить eval внутрь
процедуры определения наличия модуля, чтобы perl.req не захватывал эту
зависимость:

--- a/lib/Template/Filters.pm
+++ b/lib/Template/Filters.pm
@@ -407,9 +407,11 @@ sub use_html_entities {
 }

 sub use_apache_util {
-    require Apache::Util;
-    Apache::Util::escape_html('');      # TODO: explain this
-    return ($AVAILABLE->{ HTML_ENTITY } = \&Apache::Util::escape_html);
+    eval {
+        require Apache::Util;
+        Apache::Util::escape_html('');      # TODO: explain this
+        return ($AVAILABLE->{ HTML_ENTITY } = \&Apache::Util::escape_html);
+    }
 }

 sub html_entity_filter_factory {
@@ -418,7 +420,7 @@ sub html_entity_filter_factory {

     # if Apache::Util is installed then we use escape_html
     $haz = $AVAILABLE->{ HTML_ENTITY } 
-       ||  eval { use_apache_util()   }
+       ||  use_apache_util()
        ||  eval { use_html_entities() }
        ||  -1;      # we use -1 for "not available" because it's a true value


Идеальный вариант - наличие возможности отфильтровывать perl-зависимости в
спеке (как, например, можно в python модулях).
------- Comment #1 From 2010-11-13 16:34:42 -------
Вытягиваются пакеты apache-base apache-mod_perl-base.
Алексей, будете что-то делать?
------- Comment #2 From 2011-10-24 11:38:26 -------
perl-Template-2.22-alt1.2 -> sisyphus:

* Sun Oct 09 2011 Alexey Tourbin <at@altlinux> 2.22-alt1.2
- rebuilt for perl-5.14
- disabled dependency on Apache::Util (ALT#24241)